<template>
  <div>
    <el-row :gutter="24">
      <el-col :xs="24" :sm="8" :md="6" :lg="4" :xl="4">
        <div class="grid-content">
          <div
            class="stat-title"
          >{{ $t('label.beneficiaries-dashboard-total-regulations').toUpperCase() }}</div>
          <!-- show loading -->
          <div v-loading="isLoading" class="icon-loading" element-loading-spinner="el-icon-loading" />
          <!-- show data -->
          <div class="show-explanation color-sw-blue">
            <el-button type="text" class="no-padding underline" @click="openDialog(1)">{{ $t('label.beneficiaries-explanation') }}</el-button>
          </div>
          <div
            v-if="!isLoading"
            class="total color-sw-blue"
          >{{ getTotalBenefeciaries ? formatNumber(getTotalBenefeciaries) : '-' }}</div>
        </div>
      </el-col>
      <el-col :xs="24" :sm="8" :md="6" :lg="5" :xl="5">
        <div class="grid-content">
          <div
            class="stat-title shadow"
          >{{ $t('label.beneficiaries-dashboard-verified').toUpperCase() }}</div>
          <!-- show loading -->
          <div v-loading="isLoading" class="icon-loading" element-loading-spinner="el-icon-loading" />
          <!-- show data -->
          <div class="show-explanation color-sw-blue">
            <el-button type="text" class="no-padding underline" @click="openDialog(2)">{{ $t('label.beneficiaries-explanation') }}</el-button>
          </div>
          <span
            v-if="!isLoading"
            class="stat-count color-sw-green"
          >{{ getApproved ? formatNumber(getApproved) : '-' }}</span>
        </div>
      </el-col>
      <el-col :xs="24" :sm="8" :md="6" :lg="5" :xl="5">
        <div class="grid-content">
          <div
            class="stat-title shadow"
          >{{ $t('label.beneficiaries-dashboard-not-verified').toUpperCase() }}</div>
          <!-- show loading -->
          <div v-loading="isLoading" class="icon-loading" element-loading-spinner="el-icon-loading" />
          <!-- show data -->
          <div class="show-explanation color-sw-blue">
            <el-button type="text" class="no-padding underline" @click="openDialog(3)">{{ $t('label.beneficiaries-explanation') }}</el-button>
          </div>
          <span
            v-if="!isLoading"
            class="stat-count color-sw-orange"
          >{{ getPending ? formatNumber(getPending) : '-' }}</span>
        </div>
      </el-col>
      <el-col :xs="24" :sm="8" :md="6" :lg="5" :xl="5">
        <div class="grid-content">
          <div class="stat-title">{{ $t('label.beneficiaries-dashboard-rejected').toUpperCase() }}</div>
          <!-- show loading -->
          <div v-loading="isLoading" class="icon-loading" element-loading-spinner="el-icon-loading" />
          <!-- show data -->
          <div class="show-explanation color-sw-blue">
            <el-button type="text" class="no-padding underline" @click="openDialog(4)">{{ $t('label.beneficiaries-explanation') }}</el-button>
          </div>
          <span
            v-if="!isLoading"
            class="stat-count color-sw-red"
          >{{ getReject ? formatNumber(getReject) : '-' }}</span>
        </div>
      </el-col>
      <el-col :xs="24" :sm="8" :md="6" :lg="5" :xl="5">
        <div class="grid-content">
          <div class="stat-title">{{ $t('label.beneficiaries-dashboard-new-proposal').toUpperCase() }}</div>
          <!-- show loading -->
          <div v-loading="isLoading" class="icon-loading" element-loading-spinner="el-icon-loading" />
          <!-- show data -->
          <div class="show-explanation color-sw-blue">
            <el-button type="text" class="no-padding underline" @click="openDialog(5)">{{ $t('label.beneficiaries-explanation') }}</el-button>
          </div>
          <span
            v-if="!isLoading"
            class="stat-count color-sw-blue"
          >{{ summary.baru && summary.baru.total ? formatNumber(summary.baru.total) : '-' }}</span>
        </div>
      </el-col>
    </el-row>
    <el-dialog width="40%" custom-class="dialog-explanation" :show-close="false" :visible.sync="dialogTableVisible">
      <span slot="title" class="dialog-title-explanation">{{ $t('label.beneficiaries-description-proposal') }}</span>
      <DialogExplanation :id="idexplanationSelected" @close="dialogTableVisible = false" />
    </el-dialog>
  </div>
</template>

<script>
import { formatNumber } from '@/utils/formatNumber'
import DialogExplanation from './DialogExplanation'
export default {
  components: { DialogExplanation },
  props: {
    summary: {
      type: Object,
      default: () => {}
    },
    summaryBaru: {
      type: Object,
      default: () => {}
    },
    filter: {
      type: Object,
      default: () => {}
    },
    isLoading: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      dialogTableVisible: false,
      idexplanationSelected: null
    }
  },
  computed: {
    getApproved() {
      return (
        this.summary.approved +
        this.summary.rejected_kel +
        this.summary.approved_kel +
        this.summary.rejected_kec +
        this.summary.approved_kec +
        this.summary.rejected_kabkota +
        this.summary.approved_kabkota
      )
    },
    getPending() {
      return this.summary.pending
    },
    getReject() {
      return this.summary.rejected
    },
    getTotalBenefeciaries() {
      return this.getApproved + this.getPending + this.getReject
    }
  },
  methods: {
    percentage(val) {
      if (this.getTotalBenefeciaries && val) {
        return (val / this.getTotalBenefeciaries) * 100
      }
      return 0
    },
    openDialog(value) {
      this.dialogTableVisible = true
      this.idexplanationSelected = value
    },
    formatNumber
  }
}
</script>

<style lang="scss" scoped>
.icon-loading {
  position: absolute;
  padding-top: 20px;
}
.el-col {
  padding-top: 10px;
  border-radius: 8px;
  padding-bottom: 30px;
}
.grid-content {
  position: relative;
  box-shadow: 0px 4px 8px rgba(0, 0, 0, 0.04);
  padding: 15px;
  background: #ffff;
  border: 1px solid #e1e5ee;
  box-sizing: border-box;
  border-radius: 8px;
}
.stat-title {
  margin-bottom: 8px;
  font-weight: bold;
  font-size: 15px;
}
.total {
  font-size: 24px;
  font-weight: bolder;
}
.stat-count {
  font-size: 24px;
  font-weight: bolder;
}
.color-sw-green {
  color: #27ae60;
}
.color-sw-orange {
  color: #f2994a;
}
.color-sw-red {
  color: #eb5757;
}
.color-sw-blue {
  color: #2d9cdb;
}
.progress {
  margin-top: 15px;
}
.show-explanation {
  margin-bottom: 18px;
  font-size: 14px;
}
.underline {
  text-decoration: underline;
}
.no-padding {
  padding: 0px;
}
.dialog-title-explanation {
  font-weight: bold;
}
</style>
